diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_alter_fts_dictionary_delete_options.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_alter_fts_dictionary_delete_options.sql
new file mode 100644
index 0000000..af18224
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_alter_fts_dictionary_delete_options.sql
@@ -0,0 +1,2 @@
+ALTER TEXT SEARCH DICTIONARY public."Test Dictionary Edit#1"
+    (stopwords);
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_alter_fts_dictionary_options.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_alter_fts_dictionary_options.sql
new file mode 100644
index 0000000..e93191a
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_alter_fts_dictionary_options.sql
@@ -0,0 +1,8 @@
+ALTER TEXT SEARCH DICTIONARY public."Dictionary1_$%{}[]()&*^!@""'`\/#"
+    RENAME TO "Test Dictionary Edit#1";
+
+ALTER TEXT SEARCH DICTIONARY public."Test Dictionary Edit#1"
+    (stopwords=english);
+
+COMMENT ON TEXT SEARCH DICTIONARY public."Test Dictionary Edit#1"
+    IS 'Test Description';
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_create_fts_dictionary.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_create_fts_dictionary.sql
new file mode 100644
index 0000000..c9c248c
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/msql_create_fts_dictionary.sql
@@ -0,0 +1,3 @@
+CREATE TEXT SEARCH DICTIONARY public."Dictionary1_$%{}[]()&*^!@""'`\/#" (
+    TEMPLATE = simple
+);
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/tests.json b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/tests.json
index 5487b78..3e567fe 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/tests.json
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_dictionaries/tests/default/tests.json
@@ -5,6 +5,7 @@
       "name": "Create FTS Dictionary",
       "endpoint": "NODE-fts_dictionary.obj",
       "sql_endpoint": "NODE-fts_dictionary.sql_id",
+      "msql_endpoint": "NODE-fts_dictionary.msql",
       "data": {
         "name": "Dictionary1_$%{}[]()&*^!@\"'`\\/#",
         "template": "simple",
@@ -13,13 +14,15 @@
         "schema_id": "<SCHEMA_ID>",
         "owner": "postgres"
       },
-      "expected_sql_file": "create_fts_dictionary.sql"
+      "expected_sql_file": "create_fts_dictionary.sql",
+      "expected_msql_file": "msql_create_fts_dictionary.sql"
     },
     {
       "type": "alter",
       "name": "Alter FTS Dictionary",
       "endpoint": "NODE-fts_dictionary.obj_id",
       "sql_endpoint": "NODE-fts_dictionary.sql_id",
+      "msql_endpoint": "NODE-fts_dictionary.msql_id",
       "data": {
         "name": "Test Dictionary Edit#1",
         "description": "Test Description",
@@ -32,13 +35,15 @@
           ]
         }
       },
-      "expected_sql_file": "alter_fts_dictionary_options.sql"
+      "expected_sql_file": "alter_fts_dictionary_options.sql",
+      "expected_msql_file": "msql_alter_fts_dictionary_options.sql"
     },
     {
       "type": "alter",
       "name": "Alter FTS Dictionary | Delete Options",
       "endpoint": "NODE-fts_dictionary.obj_id",
       "sql_endpoint": "NODE-fts_dictionary.sql_id",
+      "msql_endpoint": "NODE-fts_dictionary.msql_id",
       "data": {
         "options": {
           "deleted": [
@@ -49,7 +54,8 @@
           ]
         }
       },
-      "expected_sql_file": "alter_fts_dictionary_delete_options.sql"
+      "expected_sql_file": "alter_fts_dictionary_delete_options.sql",
+      "expected_msql_file": "msql_alter_fts_dictionary_delete_options.sql"
     },
     {
       "type": "delete",